#include "MyMemReleaserRootVisitor.h"

#include <iostream>

using namespace X3DTK;
using namespace std;

MyMemReleaserRootVisitor::MyMemReleaserRootVisitor()
: MemReleaserRootVisitor()
{
  // Defines the new enter function for the X3DAbstractNode.
  defineNewEnterFunction<MyMemReleaserRootVisitor, X3DAbstractNode>(&MyMemReleaserRootVisitor::enterX3DAbstractNode);
  // Defines the new enter function for the Cylinder. This method will not be recorded 
  // because Cylinder doesn't belong to the Root component.
  defineNewEnterFunction<MyMemReleaserRootVisitor, Cylinder>(&MyMemReleaserRootVisitor::enterCylinder);
}

void MyMemReleaserRootVisitor::enterX3DAbstractNode(X3DAbstractNode *N) const
{
  // Prints the name of the node.
  cout << N->getName() << " released " << endl;
}

void MyMemReleaserRootVisitor::enterCylinder(Cylinder *C) const
{
  // empty because it will never be called.
}

