#include "MyMemReleaser.h"
#include <X3DTK/kernel.h>
#include <iostream>

using namespace X3DTK;
using namespace std;

int main(int argc, char *argv[])
{
  if (argc <= 1)
  {
    cerr << "usage: x3dconverter input" << endl;
    exit(0);
  }
  
  // DefaultLoader to load the default X3D Nodes.
  X3DLoader *loader = new DefaultLoader();
  // Instanciation of the new MemReleaser.
  MemReleaser *releaser = new MyMemReleaser();
  
  // Loads the scene.
  Scene *s = loader->load(argv[1]);
  // Releases the memory.
  releaser->release(s);
      
  return 1;
}
