////////////////////////////////////////////////////////////////////////////////
//                            BboxUpdaterGroupingVisitor.h                    //
////////////////////////////////////////////////////////////////////////////////

#ifndef BBOXUPDATERGROUPINGVISITOR_H
#define BBOXUPDATERGROUPINGVISITOR_H

#include "GroupingVisitor.h"
#include "BboxUpdaterGlobalVariables.h"

namespace X3DTK {

class StaticGroup;
class X3DGroupingNode;
class Group;
class Transform;

/// Visitor for the Grouping component of the BboxUpdater module.

class BboxUpdaterGroupingVisitor : public GroupingVisitor
{
public:
  /// Constructor.
  BboxUpdaterGroupingVisitor();
  /// Destructor.
  virtual ~BboxUpdaterGroupingVisitor();


  /// Walks on a StaticGroup.
  virtual bool walkOnStaticGroup(StaticGroup *S, SFNode Child) const;
  /// Walks on a X3DGroupingNode.
  virtual bool walkOnX3DGroupingNode(X3DGroupingNode *N, SFNode Child) const;

  /// Enters a StaticGroup.
  virtual void leaveStaticGroup(StaticGroup *S) const;
  /// Enters a X3DGroupingNode.
  virtual void leaveGroup(Group *G) const;
  /// Enters a Transform.
  virtual void leaveTransform(Transform *T) const;

protected:
  BboxUpdaterGlobalVariables *globalVariables;
};

}

#endif
