////////////////////////////////////////////////////////////////////////////////
//                            CreationFunction.h                              //
////////////////////////////////////////////////////////////////////////////////

#ifndef CREATIONFUNCTION_H
#define CREATIONFUNCTION_H

#include "X3DFunction.h"
#include "X3DTypes.h"

namespace X3DTK {

/// Abstract class defining the concept of creation function implemented by a functor.

class CreationFunction : public X3DFunction
{
public:
  /// Constructor.
  CreationFunction(const ptrToCreationFunction f, const X3DComponentCreator *component);
  /// Destructor.
  ~CreationFunction();
  
  /// Creates the node from the pointed function
  inline SFNode create() const {return (component_->*ptr2function_)();};

  inline const X3DComponentCreator *getComponent() const {return component_;};
  
private:
  /// Pointed function.
  const ptrToCreationFunction ptr2function_;
  const X3DComponentCreator *component_;
};

}

#endif
