////////////////////////////////////////////////////////////////////////////////
//                            DefaultDFSGroupingWalker.h                      //
////////////////////////////////////////////////////////////////////////////////

#ifndef DEFAULTDFSGROUPINGWALKER_H
#define DEFAULTDFSGROUPINGWALKER_H

#include "DFSGroupingWalker.h"
#include "GroupingNodes.h"

namespace X3DTK {

class StaticGroup;
class X3DGroupingNode;

/// Concrete component walker for the Grouping component.

class DefaultDFSGroupingWalker : public DFSGroupingWalker
{
public:
  /// Constructor.
  DefaultDFSGroupingWalker();
  /// Destructor.
  virtual ~DefaultDFSGroupingWalker();
  
  /// Walks a StaticGroup.
  virtual void walkStaticGroup(StaticGroup *G) const;
  /// Walks a X3DGroupingNode.
  virtual void walkX3DGroupingNode(X3DGroupingNode *N) const;
};

}

#endif
