////////////////////////////////////////////////////////////////////////////////
//                            DefaultGLDFS.h                                  //
////////////////////////////////////////////////////////////////////////////////

#ifndef DEFAULTGLDFS_H
#define DEFAULTGLDFS_H

#include "DFS.h"

namespace X3DTK {

class DefaultGLDFSGLCoreWalker;
class DefaultGLDFSGLGeometry3DWalker;
class DefaultGLDFSGLGroupingWalker;
class DefaultGLDFSGLRenderingWalker;
class DefaultGLDFSGLShapeWalker;
class DefaultGLDFSGLTexturingWalker;

/// Class defining the a tree traversal algorithm depth first search based on default 
/// X3D nodes

class DefaultGLDFS : public DFS
{
public:
  /// Constructor.
  DefaultGLDFS();
  /// Destructor.  
  virtual ~DefaultGLDFS();
  
protected:
  void setComponentWalker(X3DComponentWalker *component);
  
  DefaultGLDFSGLCoreWalker *coreWalker_;
  DefaultGLDFSGLGeometry3DWalker *geometry3DWalker_;
  DefaultGLDFSGLGroupingWalker *groupingWalker_;
  DefaultGLDFSGLRenderingWalker *renderingWalker_;
  DefaultGLDFSGLShapeWalker *shapeWalker_;
  DefaultGLDFSGLTexturingWalker *texturingWalker_;        
};

}

#endif
