////////////////////////////////////////////////////////////////////////////////
//                            DefaultGroupingCreator.h                        //
////////////////////////////////////////////////////////////////////////////////

#ifndef DEFAULTGROUPINGCREATOR_H
#define DEFAULTGROUPINGCREATOR_H

#include "GroupingCreator.h"

namespace X3DTK {

/// Concrete component Creator for the Grouping component defining the default 
/// X3D nodes.

class DefaultGroupingCreator : public GroupingCreator
{
public:
  /// Constructor.
  DefaultGroupingCreator();
  /// Destructor.
  virtual ~DefaultGroupingCreator();

  /// Creates a Group.
  SFNode createGroup() const;
  /// Creates a StaticGroup.
  SFNode createStaticGroup() const;
  /// Creates a Transform.
  SFNode createTransform() const;
};

}

#endif
