////////////////////////////////////////////////////////////////////////////////
//                            DefaultShapeCreator.h                           //
////////////////////////////////////////////////////////////////////////////////

#ifndef DEFAULTSHAPECREATOR_H
#define DEFAULTSHAPECREATOR_H

#include "ShapeCreator.h"

namespace X3DTK {

/// Concrete component Creator for the  Shape component defining the default 
/// X3D nodes.

class DefaultShapeCreator : public ShapeCreator
{
public:
  /// Constructor.
  DefaultShapeCreator();
  /// Destructor.
  virtual ~DefaultShapeCreator();
  
  /// Creates an Appearance.
  SFNode createAppearance() const;
  /// Creates a FillProperties.
  SFNode createFillProperties() const;
   /// Creates a LineProperties.
  SFNode createLineProperties() const;
   /// Creates a Material.
  SFNode createMaterial() const;
   /// Creates a Shape.
  SFNode createShape() const;
};

}

#endif
