////////////////////////////////////////////////////////////////////////////////
//                            GLConverter.h                                   //
////////////////////////////////////////////////////////////////////////////////

#ifndef GLCONVERTER_H
#define GLCONVERTER_H

#include "X3DTypes.h"

namespace X3DTK {

class GLScene;
class X3DGLCreator;
class X3DGLUpdater;

/// Class converting an X3D tree to an X3DGL tree. It performs the update of the X3DGL
/// tree too. It contains an X3DGLCreator as well as an X3DGLUpdater.

class GLConverter
{
public:
  /// Constructor.
  GLConverter();
  /// Destructor.
  ~GLConverter();

  /// Sets the GLCreator.
  void setGLCreator(X3DGLCreator *creator);
  /// Sets the GLUpdater.
  void setGLUpdater(X3DGLUpdater *updater);
    
  /// Converts the Scene S in a GLScene.
  GLScene *convert(Scene *S);

protected:
  /// GLCreator attribute.
  X3DGLCreator *_glcreator;  
  /// GLUpdater attribute.
  X3DGLUpdater *_glupdater;  
};

}

#endif
