////////////////////////////////////////////////////////////////////////////////
//                            GLCreator.h                                     //
////////////////////////////////////////////////////////////////////////////////

#ifndef GLCREATOR_H
#define GLCREATOR_H

#include "X3DGLCreator.h"
#include "GLCreatorGlobalVariables.h"
#include "DFS.h"

namespace X3DTK {

class GLScene;

/// GLCreator concept.

class GLCreator : public X3DGLCreator
{
public:
  /// Constructor.
  GLCreator();
  /// Destructor.
  virtual ~GLCreator();

  void setComponentVisitor(X3DComponentVisitor *component);
  
  /// Converts the X3D tree whom root is N, to an X3DGL tree.
  virtual X3DGLNode *create(X3DNode *N);

protected:
  GLCreatorGlobalVariables *globalVariables;
  DFS *dfs;
};

}

#endif
