////////////////////////////////////////////////////////////////////////////////
//                            GLCreatorCoreVisitor.h                          //
////////////////////////////////////////////////////////////////////////////////

#ifndef GLCREATORCOREVISITOR_H
#define GLCREATORCOREVISITOR_H

#include "CoreVisitor.h"
#include "GLCreatorGlobalVariables.h"

namespace X3DTK {

class Scene;
class X3DNode;

/// Visitor for the Core component of the GLCreator module.

class GLCreatorCoreVisitor : public CoreVisitor
{
public:
  /// Constructor.
  GLCreatorCoreVisitor();
  /// Destructor.
  virtual ~GLCreatorCoreVisitor();

  /// Enters a Scene.
  virtual void enterScene(Scene *S) const;
  /// Enters a X3DNode.
  virtual void enterX3DNode(X3DNode *N) const;

  /// Enters a Scene.
  virtual void leaveX3DNode(X3DNode *N) const;

protected:
  GLCreatorGlobalVariables *globalVariables;
};

}

#endif
