////////////////////////////////////////////////////////////////////////////////
//                            GLCreatorGeometry3DVisitor.h                    //
////////////////////////////////////////////////////////////////////////////////

#ifndef GLCREATORGEOMETRY3DVISITOR_H
#define GLCREATORGEOMETRY3DVISITOR_H

#include "Geometry3DVisitor.h"
#include "GLCreatorGlobalVariables.h"

namespace X3DTK {

class Box;
class Cone;
class Cylinder;
class IndexedFaceSet;
class Sphere;

/// Visitor for the Geometry3D component of the GLCreator module.

class GLCreatorGeometry3DVisitor : public Geometry3DVisitor
{
public:
  /// Constructor.
  GLCreatorGeometry3DVisitor();
  /// Destructor.
  virtual ~GLCreatorGeometry3DVisitor();

  /// Enters a Box.
  virtual void enterBox(Box *B) const;
  /// Enters a Cone.
  virtual void enterCone(Cone *C) const;
  /// Enters a Cylinder.
  virtual void enterCylinder(Cylinder *C) const;
  /// Enters a IndexedFaceSet.
  virtual void enterIndexedFaceSet(IndexedFaceSet *I) const;
  /// Enters a Sphere.
  virtual void enterSphere(Sphere *S) const;

  
protected:
  GLCreatorGlobalVariables *globalVariables;
};

}

#endif
