////////////////////////////////////////////////////////////////////////////////
//                            GLCreatorGlobalVariables.h                      //
////////////////////////////////////////////////////////////////////////////////

#ifndef GLCREATORGLOBALVARIABLES_H
#define GLCREATORGLOBALVARIABLES_H

#include "GlobalVariables.h"
#include "X3DGLNode.h"

namespace X3DTK {

/// GlobalVariables for the GLCreator module.

class GLCreatorGlobalVariables : public GlobalVariables
{
public:
  /// Constructor.
  GLCreatorGlobalVariables();
  /// Destructor.
  virtual ~GLCreatorGlobalVariables();
  /// Initializes the traversal.
  void init();
  /// Finishes the traversal.
  virtual void finish();
  
  /// Pushes the node.
  void pushNode(GLSFNode N);
  /// Pops the node.
  void popNode();
    
  /// Gets the GLScene.
  inline X3DGLNode *getRoot() const {return _root;};
  /// Gets the top of the stack.
  inline GLSFNode getTop() const {return _nodeStack.front();};
  
private:
  X3DGLNode *_root;
  GLMFNode _nodeStack;  
};

}

#endif
