////////////////////////////////////////////////////////////////////////////////
//                            GLCreatorGroupingVisitor.h                      //
////////////////////////////////////////////////////////////////////////////////

#ifndef GLCREATORGROUPINGVISITOR_H
#define GLCREATORGROUPINGVISITOR_H

#include "GroupingVisitor.h"
#include "GLCreatorGlobalVariables.h"

namespace X3DTK {

class Group;
class StaticGroup;
class Transform;

/// Visitor for the Grouping component of the GLCreator module.

class GLCreatorGroupingVisitor : public GroupingVisitor
{
public:
  /// Constructor.
  GLCreatorGroupingVisitor();
  /// Destructor.
  virtual ~GLCreatorGroupingVisitor();

  /// Enters a Group.
  virtual void enterGroup(Group *G) const;
  /// Enters a StaticGroup.
  virtual void enterStaticGroup(StaticGroup *S) const;
  /// Enters a Transform.
  virtual void enterTransform(Transform *T) const;

protected:
  GLCreatorGlobalVariables *globalVariables;
};

}

#endif
