////////////////////////////////////////////////////////////////////////////////
//                            GLCreatorRenderingVisitor.h                     //
////////////////////////////////////////////////////////////////////////////////

#ifndef GLCREATORRENDERINGVISITOR_H
#define GLCREATORRENDERINGVISITOR_H

#include "RenderingVisitor.h"
#include "GLCreatorGlobalVariables.h"

namespace X3DTK {

class IndexedLineSet;
class PointSet;
class TriangleFanSet;
class TriangleSet;
class TriangleStripSet;
class X3DGeometryNode;

/// Visitor for the Rendering component of the GLCreator module.

class GLCreatorRenderingVisitor : public RenderingVisitor
{
public:
  /// Constructor.
  GLCreatorRenderingVisitor();
  /// Destructor.
  virtual ~GLCreatorRenderingVisitor();

  /// Enters a IndexedLineSet.
  virtual void enterIndexedLineSet(IndexedLineSet *I) const;
  /// Enters a PointSet.
  virtual void enterPointSet(PointSet *P) const;
  /// Enters a TriangleFanSet.
  virtual void enterTriangleFanSet(TriangleFanSet *T) const;
  /// Enters a TriangleSet.
  virtual void enterTriangleSet(TriangleSet *T) const;
  /// Enters a TriangleStripSet.
  virtual void enterTriangleStripSet(TriangleStripSet *T) const;
  
  /// Walks on an X3DGeometryNode.
  virtual bool walkOnX3DGeometryNode(X3DGeometryNode *N, SFNode child) const;
  
  

protected:
  GLCreatorGlobalVariables *globalVariables;
};

}

#endif
