////////////////////////////////////////////////////////////////////////////////
//                            GLCreatorShapeVisitor.h                         //
////////////////////////////////////////////////////////////////////////////////

#ifndef GLCREATORSHAPEVISITOR_H
#define GLCREATORSHAPEVISITOR_H

#include "ShapeVisitor.h"
#include "GLCreatorGlobalVariables.h"

namespace X3DTK {

class Appearance;
class FillProperties;
class LineProperties;
class Material;
class Shape;

/// Visitor for the Shape component of the GLCreator module.

class GLCreatorShapeVisitor : public ShapeVisitor
{
public:
  /// Constructor.
  GLCreatorShapeVisitor();
  /// Destructor.
  virtual ~GLCreatorShapeVisitor();

  /// Enters a Appearance.
  virtual void enterAppearance(Appearance *A) const;
  /// Enters a FillProperties.
  virtual void enterFillProperties(FillProperties *F) const;
  /// Enters a LineProperties.
  virtual void enterLineProperties(LineProperties *L) const;
  /// Enters a Material.
  virtual void enterMaterial(Material *M) const;
  /// Enters a Shape.
  virtual void enterShape(Shape *S) const;

protected:
  GLCreatorGlobalVariables *globalVariables;
};

}

#endif
