////////////////////////////////////////////////////////////////////////////////
//                            GLCylinder.h                                    //
////////////////////////////////////////////////////////////////////////////////

#ifndef GLCYLINDER_H
#define GLCYLINDER_H

#include "X3DGLGeometry3DNode.h"

namespace X3DTK {

class Cylinder;
class CylinderDrawArray;

/// Class providing a implementation of the X3DGLNode corresponding to the X3DNode 
/// Cylinder.

class GLCylinder : public X3DGLGeometry3DNode
{
public:
  /// Constructor.
  GLCylinder();
  /// Clones the node.
  virtual SFNode clone() const;
  /// Destructor.
  virtual ~GLCylinder();
  
  /// Gets the radius.
  SFFloat &getRadius() const {return (SFFloat &)_radius;};
  /// Gets the height.
  SFFloat &getHeight() const {return (SFFloat &)_height;};
  /// Gets the side.
  SFBool &getSide() const {return (SFBool &)_side;};
  /// Gets the bottom.
  SFBool &getBottom() const {return (SFBool &)_bottom;};
  /// Gets the top.
  SFBool &getTop() const {return (SFBool &)_top;};
  /// Gets the cylinder array.
  inline CylinderDrawArray *&getCylinderDrawArray() const {return (CylinderDrawArray *&)_cylinderArray;};

protected: 
  /// Copy constructor.
  GLCylinder(const GLCylinder &C);
  
private:
  //GL attributes
  SFFloat _radius;
  SFFloat _height;
  SFBool _side;
  SFBool _bottom;
  SFBool _top;
  CylinderDrawArray *_cylinderArray;
};

}

#endif
