////////////////////////////////////////////////////////////////////////////////
//                            GLImageTexture.h                                //
////////////////////////////////////////////////////////////////////////////////

#ifndef GLIMAGETEXTURE_H
#define GLIMAGETEXTURE_H

#include "X3DGLTexture2DNode.h"

namespace X3DTK {

class ImageTexture;

/// Class providing an implementation of the X3DGLNode corresponding to the X3DNode 
/// ImageTexture.

class GLImageTexture : public X3DGLTexture2DNode
{
public:
  /// Constructor.
  GLImageTexture();
  /// Clones the node.
  virtual SFNode clone() const;
  /// Destructor.
  ~GLImageTexture();
  
  /// Gets the texName.
  inline GLuint &getTexName() const {return (GLuint &)_texName;};
  /// Gets the ratioS.
  inline MFFloat &getTextureTransform() const {return (MFFloat &)_textureTransform;};

protected:  
  /// Copy constructor.	     
  GLImageTexture(const GLImageTexture &I);
  
private:
  //GL attributes
  GLuint _texName;
  MFFloat _textureTransform;
};

}

#endif
