////////////////////////////////////////////////////////////////////////////////
//                            GLNormalRendererGLGeometry3DVisitor.h           //
////////////////////////////////////////////////////////////////////////////////

#ifndef GLNORMALRENDERERGLGEOMETRY3DVISITOR_H
#define GLNORMALRENDERERGLGEOMETRY3DVISITOR_H

#include "GLGeometry3DVisitor.h"

namespace X3DTK {

class GLBox;
class GLCone;
class GLCylinder;
class GLIndexedFaceSet;
class GLSphere;

/// Visitor for the GLGeometry3D component of the GLNormalRenderer module.

class GLNormalRendererGLGeometry3DVisitor : public GLGeometry3DVisitor
{
public:
  /// Constructor.
  GLNormalRendererGLGeometry3DVisitor();
  /// Destructor.
  virtual ~GLNormalRendererGLGeometry3DVisitor();

  /// Enters a GLBox.
  virtual void enterGLBox(GLBox *G) const;
  /// Enters a GLCone.
  virtual void enterGLCone(GLCone *G) const;
  /// Enters a GLCylinder.
  virtual void enterGLCylinder(GLCylinder *G) const;
  /// Enters a GLIndexedFaceSet.
  virtual void enterGLIndexedFaceSet(GLIndexedFaceSet *G) const;
  /// Enters a GLSphere.
  virtual void enterGLSphere(GLSphere *G) const;
};

}

#endif
