////////////////////////////////////////////////////////////////////////////////
//                            GLPointSet.h                                    //
////////////////////////////////////////////////////////////////////////////////

#ifndef GLPOINTSET_H
#define GLPOINTSET_H

#include "X3DGLGeometryNode.h"

#include <vector>

namespace X3DTK {

class PointSet;

/// Class providing a implementation of the X3DGLNode corresponding to the X3DNode 
/// PointSet.

class GLPointSet : public X3DGLGeometryNode
{
public:
  /// Constructor.
  GLPointSet();
  /// Clones the node.
  virtual SFNode clone() const;
  /// Destructor.
  ~GLPointSet();

  /// gets the color.
  inline SFBool &getColor() const {return (SFBool &)_color;};
  /// Gets the pointArray.
  inline MFVec3f &getPointArray() const {return (MFVec3f &)_pointArray;};
  /// Gets the lineArrayArray.
  inline std::vector<C4UB_V3F> &getPointSetArray() const {return (std::vector<C4UB_V3F> &)_pointSetArray;};

protected: 
  /// Copy constructor.	       
  GLPointSet(const GLPointSet &P);
  
private:
  //GL attributes
  SFBool _color;
  
  MFVec3f _pointArray;
  std::vector<C4UB_V3F> _pointSetArray;
};

}

#endif
