////////////////////////////////////////////////////////////////////////////////
//                            GLRenderer.h                                    //
////////////////////////////////////////////////////////////////////////////////

#ifndef GLRENDERER_H
#define GLRENDERER_H

#include "X3DGLRenderer.h"
#include "GLRendererGlobalVariables.h"
#include "DFS.h"

namespace X3DTK {

class GLScene;

/// GLRenderer module.

class GLRenderer : public X3DGLRenderer
{
public:
  /// Constructor.
  GLRenderer();
  /// Destructor.
  virtual ~GLRenderer();
  
  void setComponentVisitor(X3DComponentVisitor *component);
  
  /// Renders a GLScene.
  virtual void render(X3DGLNode *N) const;

protected:
  GLRendererGlobalVariables *globalVariables;
  DFS *dfs;
};

}

#endif
