////////////////////////////////////////////////////////////////////////////////
//                            GLRendererGLGeometry3DVisitor.h                 //
////////////////////////////////////////////////////////////////////////////////

#ifndef GLRENDERERGLGEOMETRY3DVISITOR_H
#define GLRENDERERGLGEOMETRY3DVISITOR_H

#include "GLGeometry3DVisitor.h"
#include "GLRendererGlobalVariables.h"

namespace X3DTK {

class GLBox;
class GLCone;
class GLCylinder;
class GLIndexedFaceSet;
class GLSphere;

/// Visitor for the GLGeometry3D component of the GLRenderer module.

class GLRendererGLGeometry3DVisitor : public GLGeometry3DVisitor
{
public:
  /// Constructor.
  GLRendererGLGeometry3DVisitor();
  /// Destructor.
  virtual ~GLRendererGLGeometry3DVisitor();

  /// Enters a GLBox.
  virtual void enterGLBox(GLBox *G) const;
  /// Enters a GLCone.
  virtual void enterGLCone(GLCone *G) const;
  /// Enters a GLCylinder.
  virtual void enterGLCylinder(GLCylinder *G) const;
  /// Enters a GLIndexedFaceSet.
  virtual void enterGLIndexedFaceSet(GLIndexedFaceSet *G) const;
  /// Enters a GLSphere.
  virtual void enterGLSphere(GLSphere *G) const;



protected:
  GLRendererGlobalVariables *globalVariables;
};

}

#endif
