////////////////////////////////////////////////////////////////////////////////
//                            GLRendererGLGroupingVisitor.h                   //
////////////////////////////////////////////////////////////////////////////////

#ifndef GLRENDERERGLGROUPINGVISITOR_H
#define GLRENDERERGLGROUPINGVISITOR_H

#include "GLGroupingVisitor.h"
#include "GLRendererGlobalVariables.h"

namespace X3DTK {

class GLGroup;
class GLStaticGroup;
class GLTransform;

/// Visitor for the GLGrouping component of the GLRenderer module.

class GLRendererGLGroupingVisitor : public GLGroupingVisitor
{
public:
  /// Constructor.
  GLRendererGLGroupingVisitor();
  /// Destructor.
  virtual ~GLRendererGLGroupingVisitor();

  /// Enters a GLGroup.
  virtual void enterGLGroup(GLGroup *G) const;
  /// Enters a GLStaticGroup.
  virtual void enterGLStaticGroup(GLStaticGroup *G) const;
  /// Enters a GLTransform.
  virtual void enterGLTransform(GLTransform *G) const;

  /// Leaves a GLTransform.
  virtual void leaveGLTransform(GLTransform *G) const;

protected:
  GLRendererGlobalVariables *globalVariables;
};

}

#endif
