////////////////////////////////////////////////////////////////////////////////
//                            GLRendererGLShapeVisitor.h                      //
////////////////////////////////////////////////////////////////////////////////

#ifndef GLRENDERERGLSHAPEVISITOR_H
#define GLRENDERERGLSHAPEVISITOR_H

#include "GLShapeVisitor.h"
#include "GLRendererGlobalVariables.h"

namespace X3DTK {

class GLAppearance;
class GLFillProperties;
class GLLineProperties;
class GLMaterial;
class GLShape;

/// Visitor for the GLShape component of the GLRenderer module.

class GLRendererGLShapeVisitor : public GLShapeVisitor
{
public:
  /// Constructor.
  GLRendererGLShapeVisitor();
  /// Destructor.
  virtual ~GLRendererGLShapeVisitor();

  /// Enters a GLAppearance.
  virtual void enterGLAppearance(GLAppearance *G) const;
  /// Enters a GLFillProperties.
  virtual void enterGLFillProperties(GLFillProperties *G) const;
  /// Enters a GLLineProperties.
  virtual void enterGLLineProperties(GLLineProperties *G) const;
  /// Enters a GLMaterial.
  virtual void enterGLMaterial(GLMaterial *G) const;
  /// Enters a GLGLShape.
  virtual void enterGLShape(GLShape *G) const;



protected:
  GLRendererGlobalVariables *globalVariables;
};

}

#endif
