////////////////////////////////////////////////////////////////////////////////
//                            GLSphere.h                                      //
////////////////////////////////////////////////////////////////////////////////

#ifndef GLSPHERE_H
#define GLSPHERE_H

#include "X3DGLGeometry3DNode.h"

namespace X3DTK {

class Sphere;
class SphereDrawArray;

/// Class providing a implementation of the X3DGLNode corresponding to the X3DNode 
/// Sphere.

class GLSphere : public X3DGLGeometry3DNode
{
public:
  /// Constructor.
  GLSphere();
  /// Clones the node.
  virtual SFNode clone() const;
  /// Destructor.
  ~GLSphere();
  
  /// Gets the radius.
  inline SFFloat &getRadius() const {return (SFFloat &)_radius;};
  /// Gets the sphere array.
  inline SphereDrawArray *&getSphereDrawArray() const {return (SphereDrawArray *&)_sphereArray;};
  
protected:
  /// Copy constructor.	 
  GLSphere(const GLSphere &S);
  
private:
  //GL attributes
  SFFloat _radius;
  SphereDrawArray *_sphereArray;
};

}

#endif
