////////////////////////////////////////////////////////////////////////////////
//                            GLStaticGroup.h                                 //
//////////////////////////////////////////////////////////////////////////////// 

#ifndef GLSTATICGROUP_H
#define GLSTATICGROUP_H

#include "X3DGLChildNode.h"

namespace X3DTK {

class StaticGroup;

/// Class providing a implementation of the X3DGLNode corresponding to the X3DNode 
/// StaticGroup.

class GLStaticGroup : public X3DGLChildNode
{
public:
  /// Constructor.
  GLStaticGroup();
  /// Clones the node.
  virtual SFNode clone() const;
  /// Destructor.
  ~GLStaticGroup();
  
  /// Adds a child to the Children attribute. Return TRUE if succeeds.
  virtual bool addChild(const SFNode &N);
  /// Sets the child. Behaves like addChild.
  virtual bool setChild(const SFNode &N);
  /// Removes the child. Return TRUE if succeeds.
  virtual bool removeChild(const SFNode &N);

  /// Gets the Children attribute.
  inline MFNode getChildren() const {return _children;};

protected:  
  /// Copy constructor.		
  GLStaticGroup(const GLStaticGroup &G);
   
  /// Removes the sceneList to the children.
  virtual void removeScenesToChildren(const MFScene &sceneList);
  /// Adds the sceneList to the children.
  virtual void addScenesToChildren(const MFScene &sceneList);
   
private:
  MFNode _children;
};

}

#endif
