////////////////////////////////////////////////////////////////////////////////
//                            GLUpdaterGLShapeVisitor.h                       //
////////////////////////////////////////////////////////////////////////////////

#ifndef GLUPDATERGLSHAPEVISITOR_H
#define GLUPDATERGLSHAPEVISITOR_H

#include "GLShapeVisitor.h"
#include "GLUpdaterGlobalVariables.h"

namespace X3DTK {

class GLAppearance;
class GLFillProperties;
class GLLineProperties;
class GLMaterial;
class GLGLShape;

/// Visitor for the GLShape component of the GLUpdater module.

class GLUpdaterGLShapeVisitor : public GLShapeVisitor
{
public:
  /// Constructor.
  GLUpdaterGLShapeVisitor();
  /// Destructor.
  virtual ~GLUpdaterGLShapeVisitor();

  /// Enters a GLFillProperties.
  virtual void enterGLFillProperties(GLFillProperties *G) const;
  /// Enters a GLLineProperties.
  virtual void enterGLLineProperties(GLLineProperties *G) const;
  /// Enters a GLMaterial.
  virtual void enterGLMaterial(GLMaterial *G) const;



protected:
  GLUpdaterGlobalVariables *globalVariables;
};

}

#endif
