////////////////////////////////////////////////////////////////////////////////
//                            GVManager.h                                     //
////////////////////////////////////////////////////////////////////////////////

#ifndef GLOBALVARIABLESMANAGER_H
#define GLOBALVARIABLESMANAGER_H

#include <list>

#include "GlobalVariables.h"

namespace X3DTK {

/// Class managing the set of GlobalVariables. It is a static class.

class GVManager
{
public:
  template <class G>
  static G *getInstanceOf()
  {
    for (std::list<GlobalVariables *>::iterator it = globalVariablesList_.begin(); it != globalVariablesList_.end(); ++it)
    {
      if (dynamic_cast<G *>(*it) != 0)
        return static_cast<G *>(*it);       
    }
    G *g = new G();
    globalVariablesList_.push_back(g);
    return g;
  };

private:
  static std::list<GlobalVariables *> globalVariablesList_;  
};

}

#endif
