////////////////////////////////////////////////////////////////////////////////
//                            LeaveFunction.h                                 //
////////////////////////////////////////////////////////////////////////////////

#ifndef LEAVEFUNCTION_H
#define LEAVEFUNCTION_H

#include "X3DActiveFunction.h"
#include "X3DTypes.h"

namespace X3DTK {

/// Abstract class defining the concept of leave function implemented by a functor.

class LeaveFunction : public X3DActiveFunction
{
public:
  /// Constructor.
  LeaveFunction(const ptrToLeaveFunction leave, const X3DComponentVisitor *component);
  /// Destructor.
  ~LeaveFunction();
  
  /// Leave the node.
  inline void leave(SFNode N) const {(component_->*ptr2leave_)(N);};
  
private:
  const ptrToLeaveFunction ptr2leave_;
  const X3DComponentVisitor *component_;
};

}

#endif
