////////////////////////////////////////////////////////////////////////////////
//                            MemReleaserGlobalVariables.h                    //
////////////////////////////////////////////////////////////////////////////////

#ifndef MEMRELEASERGLOBALVARIABLES_H
#define MEMRELEASERGLOBALVARIABLES_H

#include "GlobalVariables.h"

namespace X3DTK {

/// GlobalVariables for the MemReleaser module.

class MemReleaserGlobalVariables : public GlobalVariables
{
public:
  /// Constructor.
  MemReleaserGlobalVariables();
  /// Destructor.
  virtual ~MemReleaserGlobalVariables();

  /// Pushes the parent.
  void pushParent(SFNode P);
  /// Pops the parent.
  void popParent();
  /// Sets the current node to be deleted.
  void setDelete(bool value);
  
  /// Gets the parent.
  SFNode getParent() const {return _nodeStack.front();};
  /// Gets the current node to be deleted or not.
  bool getDelete() const {return _toDelete;};

private: 
  MFNode _nodeStack;
  bool _toDelete;  
};

}

#endif
