////////////////////////////////////////////////////////////////////////////////
//                            RootVisitor.h                                   //
////////////////////////////////////////////////////////////////////////////////

#ifndef ROOTVISITOR_H
#define ROOTVISITOR_H

#include "X3DComponentVisitor.h"

namespace X3DTK {

/// Concrete component Visitor for the Root component.

class RootVisitor : public X3DComponentVisitor
{
public:
  /// Constructor.
  RootVisitor();
  /// Destructor.
  virtual ~RootVisitor();
  
  /// Enters an X3DAbstractNode.
  virtual void enterX3DAbstractNode(X3DAbstractNode *N) const;
  /// Walks on an X3DAbstractNode.
  virtual bool walkOnX3DAbstractNode(X3DAbstractNode *N, SFNode child) const;
  /// Enters an X3DAbstractNode.
  virtual void leaveX3DAbstractNode(X3DAbstractNode *N) const;
};

}

#endif
