////////////////////////////////////////////////////////////////////////////////
//                            SceneToFile.h                                   //
////////////////////////////////////////////////////////////////////////////////

#ifndef SCENETOFILE_H
#define SCENETOFILE_H

#include "X3DSceneToFile.h"
#include "SceneToFileGlobalVariables.h"
#include "DFS.h"

class Scene;

namespace X3DTK {

/// SceneToFile module.

class SceneToFile : public X3DSceneToFile
{
public:
  /// Constructor.
  SceneToFile(DFS *dfs = 0);
  /// Destructor.
  virtual ~SceneToFile();
  
  void setComponentVisitor(X3DComponentVisitor *component);
  
  /// Writes the content of S in file.
  virtual void toFile(Scene *S, const SFString &file) const;

protected:
  SceneToFileGlobalVariables *globalVariables;
  bool defaultDFSUSE;
  DFS *dfs; 
};

}

#endif
