////////////////////////////////////////////////////////////////////////////////
//                            X3DMaterialNode.h                               //
////////////////////////////////////////////////////////////////////////////////

#ifndef X3DMATERIALNODE_H
#define X3DMATERIALNODE_H

#include "X3DAppearanceChildNode.h"

namespace X3DTK {

/// Base class of the <a href="../../doc/X3D_Specs/Part01/components/shape.html">Shape 
/// component</a> defining an X3DMaterialNode
/// (<a href="../../doc/X3D_Specs/Part01/components/Shape.html#X3DMaterialNode">
/// X3D documentation</a>).

class X3DMaterialNode : public X3DAppearanceChildNode
{
public:
  /// Constructor.
  X3DMaterialNode();
  /// Clones the node.
  virtual SFNode clone() const;
  /// Virtual destructor.
  virtual ~X3DMaterialNode();

protected:
  /// Copy constructor.
  X3DMaterialNode(const X3DMaterialNode &N);
};

}

#endif
