////////////////////////////////////////////////////////////////////////////////
//                            X3DNode.h                                       //
////////////////////////////////////////////////////////////////////////////////

#ifndef X3DNODE_H
#define X3DNODE_H

#include "X3DAbstractNode.h"

namespace X3DTK {

/// Base class of the <a href="../../doc/X3D_Specs/Part01/components/core.html">
/// Core component</a> defining an X3DNode 
/// (<a href="../../doc/X3D_Specs/Part01/components/core.html#X3DNode">
/// X3D documentation</a>) for all nodes in the X3D system.

class X3DNode : public X3DAbstractNode
{
public:
  /// Constructor.
  X3DNode();
  /// Clones the node.
  virtual SFNode clone() const;
  /// Virtual destructor.
  virtual ~X3DNode();

protected:
  /// Copy constructor.
  X3DNode(const X3DNode &N);
  
};

}

#endif
