////////////////////////////////////////////////////////////////////////////////
//                            X3DNodeProxy.h                                  //
////////////////////////////////////////////////////////////////////////////////

#ifndef X3DNODEPROXY_H
#define X3DNODEPROXY_H

#include "X3DTypes.h"

namespace X3DTK {

class Type;

/// Abstract base class defining an X3DNodeProxy.

class X3DNodeProxy
{
public:  
  /// Constructor.
  X3DNodeProxy();
  /// Destructor.
  virtual ~X3DNodeProxy() = 0;
  // Deletes the components when the proxy is deleted.
  void setAutoDeleteComponents(bool value);
  /// Empties the list of component and delete them if deleteComponents is TRUE
  /// and autoDelete is TRUE.
  virtual void reset() = 0;
  
protected:  
  /// Adds a type.
  virtual void addType(const Type *type) = 0;
    
  /// If autoDelete is set to TRUE, when the proxy is removed, the components are 
  /// removed too.
  bool autoDelete;
  
  friend class Type; 
};

}

#endif
