////////////////////////////////////////////////////////////////////////////////
//                            X3DTypesToSFString.h                            //
////////////////////////////////////////////////////////////////////////////////

#ifndef X3DTYPESTOSFSTRING_H
#define X3DTYPESTOSFSTRING_H

#include "X3DTypes.h"

namespace X3DTK {

/// Returns the SFString DEF="DEF" USE="USE".
SFString toSFString(const SFString &DEF, const SFString &USE);

/// Converts mf to an SFString.
SFString toSFString(const MFString ms);

/// Converts b to an SFString.
SFString toSFString(const SFBool b); 
/// Converts i to an SFString.
SFString toSFString(const SFInt32 i); 
/// Converts mi to an SFString.
SFString toSFString(const MFInt32 mi);
/// Converts f to an SFString.
SFString toSFString(const SFFloat f);
/// Converts mf to an SFString.
SFString toSFString(const MFFloat mf);
/// Converts d to an SFString.
SFString toSFString(const SFDouble d); 
/// Converts md to an SFString.
SFString toSFString(const MFDouble md);
/// Converts c to an SFString.
SFString toSFString(const SFColorRGBA c);
/// Converts mc to an SFString.
SFString toSFString(const MFColorRGBA mc);
/// Converts c to an SFString.
SFString toSFString(const SFColor c); 
/// Converts mc to an SFString.
SFString toSFString(const MFColor mc);    
/// Converts v to an SFString.
SFString toSFString(const SFVec2f v);
/// Converts mv to an SFString.
SFString toSFString(const MFVec2f mv);
/// Converts v to an SFString.
SFString toSFString(const SFVec3f v);
/// Converts mv to an SFString.
SFString toSFString(const MFVec3f mv);
/// Converts r to an SFString.
SFString toSFString(const SFRotation r);

}

#endif
