////////////////////////////////////////////////////////////////////////////////
//                            XercesLoader.h                                  //
////////////////////////////////////////////////////////////////////////////////

#ifndef XERCESLOADER_H
#define XERCESLOADER_H

#include "X3DLoader.h"

namespace X3DTK {

class XercesLoaderImplementation;
class NodeCreationProxy;

/// X3D file loader based on a Xerces SAX2 reader.

class XercesLoader : public X3DLoader
{
public:
  /// Constructor.
  XercesLoader(NodeCreationProxy *nodeCreationProxy);
  /// Destructor.
  ~XercesLoader();
  
  /// Loads a scene from the file.
  Scene *load(const char *file, bool fileValidation = false) const;
  
private:
  XercesLoaderImplementation *_impl;
};

}

#endif
