/// This file is part of the QGLViewer library
/// Copyright (C) 2002-2003  Yannick Le Goc (legoc@imag.fr)

/// http://www-imagis.imag.fr/Membres/Yannick.Legoc/X3D/


/// X3DToolKit is free software; you can redistribute it and/or modify
/// it under the terms of the GNU General Public License as published by
/// the Free Software Foundation; either version 2 of the License, or
/// (at your option) any later version.

/// X3DToolKit is distributed in the hope that it will be useful,
/// but WITHOUT ANY WARRANTY; without even the implied warranty of
/// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
/// GNU General Public License for more details.

/// You should have received a copy of the GNU General Public License
/// along with X3DToolKit; if not, write to the Free Software
/// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA



/// Ce programme est libre, vous pouvez le redistribuer et/ou le modifier
/// selon les termes de la Licence Publique Gnrale GNU publie par la Free
/// Software Foundation (version 2 ou bien toute autre version ultrieure
/// choisie par vous).

/// Ce programme est distribu car potentiellement utile, mais SANS AUCUNE
/// GARANTIE, ni explicite ni implicite, y compris les garanties de
/// commercialisation ou d'adaptation dans un but spcifique. Reportez-vous
///  la Licence Publique Gnrale GNU pour plus de dtails.

/// Vous devez avoir reu une copie de la Licence Publique Gnrale GNU en
/// mme temps que ce programme ; si ce n'est pas le cas, crivez  la Free
/// Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
/// 02111-1307, tats-Unis. 

////////////////////////////////////////////////////////////////////////////////
//                            LeaveFunction.h                                 //
////////////////////////////////////////////////////////////////////////////////

#ifndef LEAVEFUNCTION_H
#define LEAVEFUNCTION_H

#include "X3DActiveFunction.h"
#include "X3DTypes.h"

namespace X3DTK {

/// Abstract class defining the concept of leave function implemented by a functor.

class LeaveFunction : public X3DActiveFunction
{
public:
  /// Constructor.
  LeaveFunction(const ptrToLeaveFunction leave, const X3DComponentVisitor *component);
  /// Destructor.
  ~LeaveFunction();
  
  /// Leave the node.
  inline void leave(SFNode N) const {(component_->*ptr2leave_)(N);};
  
private:
  const ptrToLeaveFunction ptr2leave_;
  const X3DComponentVisitor *component_;
};

}

#endif
