#include "Component.h"
#include "Type.h"

#include <iostream>

using namespace std;
using namespace X3DTK;

MFComponent Component::_componentList = MFComponent();

Component::Component(const SFString &name)
: _name(name), _refCount(0), _typeList(MFType())
{
  //cout << "new Component " << name << endl;
  _componentList[name] = this;
}

Component::~Component()
{
  //cout << "delete Component " << _name << endl;
}

Component *Component::getComponent(const SFString &name)
{
  MFComponent::const_iterator it = _componentList.find(name); 
  if (it != _componentList.end())
    return (*it).second;
    
  //the type doesn't exist.
  return 0;  
}

void Component::addOneReference()
{
  ++_refCount;
  //cout << "add ref Component " << _name << " = " << _refCount << endl;
}

void Component::removeOneReference(Component *component)
{
  --component->_refCount;
  //cout << "remove ref Component " << component->getName() << " = " << component->_refCount << endl;
  
  if (component->_refCount == 0)
  {
    // delete component
    _componentList.erase(component->_name);
    delete component;
  }
}


void Component::addType(Type *type)
{
  _typeList[type->getName()] = type;
}
