#include "NameDict.h"

#include <iostream>

using namespace X3DTK;
using namespace std;

NameDict::NameDict()
{
}

NameDict::~NameDict()
{
  _nameDict.clear();
}
  
void NameDict::insert(const SFString &name, const SFNode &N)
{
  _nameDict.insert(X3DDict::value_type(name, N));
}

void NameDict::remove(SFNode N)
{
  for (X3DDict::iterator it = _nameDict.begin(); it != _nameDict.end(); ++it)
  {
    if ((*it).second == N)
    {
      _nameDict.erase(it);
      return;
    }  
  }
}

void NameDict::makeDEFNonAmbiguous()
{
  X3DDict nameDictCopy;
  nameDictCopy.swap(_nameDict);
  
  //iterating the elements of the dict.
  for (X3DDict::iterator it = nameDictCopy.begin(); it != nameDictCopy.end(); ++it)
  {
    SFString name = (*it).first;
    SFString nname = name;    
    
    unsigned int k = 1;
    while (_nameDict.find(nname) != _nameDict.end())
    {
      nname = name + "_" + SFString::number(k);
      ++k;
    }
    _nameDict.insert(X3DDict::value_type(nname, (*it).second));
  }
}

SFNode NameDict::getNodeOfName(const SFString &name) const
{
  X3DDict::const_iterator it = _nameDict.find(name);
  if (it != _nameDict.end())
    return (*it).second;
  return 0;  
}

SFString NameDict::getNameOfNode(const SFNode &N) const
{
  for (X3DDict::const_iterator it = _nameDict.begin(); it != _nameDict.end(); ++it)
  {
    if ((*it).second == N)
      return (*it).first;
  }
  
  return SFString("");
}

void NameDict::printDict() const
{
  cout << "DEF dictionary" << endl;
  for (X3DDict::const_iterator it = _nameDict.begin(); it != _nameDict.end(); ++it)
    cout << (*it).first << " -> " << (*it).second << endl;  
  cout << "end dictionary" << endl;  
} 
