#include "X3DComponentCreator.h"

using namespace X3DTK;
using namespace std;

X3DComponentCreator::X3DComponentCreator()
{
}

X3DComponentCreator::~X3DComponentCreator()
{
  //delete the creation functions
  for (CreationDict::iterator it = creationDict_.begin(); it != creationDict_.end(); ++it)
    delete (*it).second;
}

CreationFunction *X3DComponentCreator::getCreationFunctionOf(const SFString &name) const
{
  CreationDict::const_iterator it = creationDict_.find(name);
  if (it != creationDict_.end())
    return (*it).second;
  
  return 0;  
}

bool X3DComponentCreator::contains(const SFString &name) const
{
  return (creationDict_.find(name) != creationDict_.end());
}

  
