#include "DFS.h"
#include "NodeVisitingProxy.h"
#include "NodeWalkingProxy.h"

#include <iostream>

using namespace X3DTK;
using namespace std;

DFS::DFS()
: X3DTTAlgorithm()
{
}

DFS::~DFS()
{
}

DFS *X3DTK::joinDFS(DFS *D1, DFS *D2)
{
  DFS *D = new DFS();
  
  D->nvp = joinNodeVisitingProxies(D1->nvp, D2->nvp);
  D->nwp = joinNodeWalkingProxies(D1->nwp, D2->nwp);
  D->nwp->setNodeVisitingProxy(D->nvp);
  
  return D;
}

DFS *X3DTK::mergeDFS(DFS *D1, DFS *D2)
{
  DFS *D = new DFS();
  
  delete D->nvp;
  delete D->nwp;
  
  D->nvp = joinNodeVisitingProxies(D1->nvp, D2->nvp);
  D->nwp = joinNodeWalkingProxies(D1->nwp, D2->nwp);
  D->nwp->setNodeVisitingProxy(D->nvp);
  
  delete D1;
  delete D2;
  
  return D;
}
