#include "DefaultGLDFSGLRenderingWalker.h"
#include "NodeWalkingProxy.h"
#include "NodeVisitingProxy.h"
#include "GLRenderingNodes.h"

using namespace X3DTK;

DefaultGLDFSGLRenderingWalker::DefaultGLDFSGLRenderingWalker()
: DFSGLRenderingWalker()
{
  defineNewWalkingFunction<DefaultGLDFSGLRenderingWalker, X3DGLComposedGeometryNode>(&DefaultGLDFSGLRenderingWalker::walkX3DGLComposedGeometryNode);
  defineNewWalkingFunction<DefaultGLDFSGLRenderingWalker, GLIndexedLineSet>(&DefaultGLDFSGLRenderingWalker::walkGLIndexedLineSet);
  defineNewWalkingFunction<DefaultGLDFSGLRenderingWalker, GLPointSet>(&DefaultGLDFSGLRenderingWalker::walkGLPointSet);
}

DefaultGLDFSGLRenderingWalker::~DefaultGLDFSGLRenderingWalker()
{
}

void DefaultGLDFSGLRenderingWalker::walkX3DGLComposedGeometryNode(X3DGLComposedGeometryNode *N) const
{
  nodeVisitingProxy->enter(N);
  nodeVisitingProxy->leave(N);
}

void DefaultGLDFSGLRenderingWalker::walkGLIndexedLineSet(GLIndexedLineSet *I) const
{
  nodeVisitingProxy->enter(I);
  nodeVisitingProxy->leave(I);
}

void DefaultGLDFSGLRenderingWalker::walkGLPointSet(GLPointSet *P) const
{
  nodeVisitingProxy->enter(P);
  nodeVisitingProxy->leave(P);
}
