#include "DefaultGLDFSGLShapeWalker.h"
#include "NodeWalkingProxy.h"
#include "NodeVisitingProxy.h"
#include "GLShapeNodes.h"

using namespace X3DTK;

DefaultGLDFSGLShapeWalker::DefaultGLDFSGLShapeWalker()
: DFSGLShapeWalker()
{
  defineNewWalkingFunction<DefaultGLDFSGLShapeWalker, X3DGLShapeNode>(&DefaultGLDFSGLShapeWalker::walkX3DGLShapeNode);  
  defineNewWalkingFunction<DefaultGLDFSGLShapeWalker, GLAppearance>(&DefaultGLDFSGLShapeWalker::walkGLAppearance);  
}

DefaultGLDFSGLShapeWalker::~DefaultGLDFSGLShapeWalker()
{
}

void DefaultGLDFSGLShapeWalker::walkX3DGLShapeNode(X3DGLShapeNode *N) const
{
  nodeVisitingProxy->enter(N);
  
  SFNode C;
  C = N->getAppearance();
  if ((C != 0) && (nodeVisitingProxy->walkOn(N, C)))
    nodeWalkingProxy->walk(C);
  
  C = N->getGeometry();
  if ((C != 0) && (nodeVisitingProxy->walkOn(N, C)))
    nodeWalkingProxy->walk(C);
    
  nodeVisitingProxy->leave(N);
}

void DefaultGLDFSGLShapeWalker::walkGLAppearance(GLAppearance *A) const
{
  nodeVisitingProxy->enter(A);
  
  SFNode C;
  C = A->getMaterial();
  if ((C != 0) && (nodeVisitingProxy->walkOn(A, C)))
    nodeWalkingProxy->walk(C);
    
  C = A->getTexture();
  if ((C != 0) && (nodeVisitingProxy->walkOn(A, C)))
    nodeWalkingProxy->walk(C);

  C = A->getTextureTransform();
  if ((C != 0) && (nodeVisitingProxy->walkOn(A, C)))
    nodeWalkingProxy->walk(C);

  C = A->getLineProperties();
  if ((C != 0) && (nodeVisitingProxy->walkOn(A, C)))
    nodeWalkingProxy->walk(C);

  C = A->getFillProperties();
  if ((C != 0) && (nodeVisitingProxy->walkOn(A, C)))
    nodeWalkingProxy->walk(C);
    
  nodeVisitingProxy->leave(A);
}
