/// This file is part of the QGLViewer library
/// Copyright (C) 2002-2003  Yannick Le Goc (legoc@imag.fr)

/// http://www-imagis.imag.fr/Membres/Yannick.Legoc/X3D/


/// X3DToolKit is free software; you can redistribute it and/or modify
/// it under the terms of the GNU General Public License as published by
/// the Free Software Foundation; either version 2 of the License, or
/// (at your option) any later version.

/// X3DToolKit is distributed in the hope that it will be useful,
/// but WITHOUT ANY WARRANTY; without even the implied warranty of
/// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
/// GNU General Public License for more details.

/// You should have received a copy of the GNU General Public License
/// along with X3DToolKit; if not, write to the Free Software
/// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA



/// Ce programme est libre, vous pouvez le redistribuer et/ou le modifier
/// selon les termes de la Licence Publique Gnrale GNU publie par la Free
/// Software Foundation (version 2 ou bien toute autre version ultrieure
/// choisie par vous).

/// Ce programme est distribu car potentiellement utile, mais SANS AUCUNE
/// GARANTIE, ni explicite ni implicite, y compris les garanties de
/// commercialisation ou d'adaptation dans un but spcifique. Reportez-vous
///  la Licence Publique Gnrale GNU pour plus de dtails.

/// Vous devez avoir reu une copie de la Licence Publique Gnrale GNU en
/// mme temps que ce programme ; si ce n'est pas le cas, crivez  la Free
/// Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
/// 02111-1307, tats-Unis. 

////////////////////////////////////////////////////////////////////////////////
//                            X3DGLNode.h                                     //
////////////////////////////////////////////////////////////////////////////////

#ifndef X3DGLNODE_H
#define X3DGLNODE_H

#include "X3DAbstractNode.h"
#include "X3DNode.h"
#include "X3DGLTypes.h"

#include <GL/gl.h>

namespace X3DTK {

/// Base class of the Core component. A set of X3DGLNode represents a scene graph
/// related with the X3D scene graph. Each X3DNode able to be drawn directly has 
/// its X3DGLNode correspondence. For example X3DIndexedFaceSet is related with 
/// GLIndexedFaceSet, whereas Coordinate has no X3DGLNode correspondent. 

class X3DGLNode : public X3DAbstractNode
{
public:
  /// Constructor.
  X3DGLNode();
  /// Clones the node.
  virtual SFNode clone() const;
  /// Virtual destructor.
  virtual ~X3DGLNode();
  
  /// Sets the link.
  void setLink(X3DNode *N);
  /// Returns the X3DNode equivalent.
  inline SFNode getLink() const {return link;};
  
protected:
  /// Copy constructor.
  X3DGLNode(const X3DGLNode &N);
  
  /// Pointer to the X3DNode equivalent.
  X3DNode *link;
};

}

#endif
