/// This file is part of the QGLViewer library
/// Copyright (C) 2002-2003  Yannick Le Goc (legoc@imag.fr)

/// http://www-imagis.imag.fr/Membres/Yannick.Legoc/X3D/


/// X3DToolKit is free software; you can redistribute it and/or modify
/// it under the terms of the GNU General Public License as published by
/// the Free Software Foundation; either version 2 of the License, or
/// (at your option) any later version.

/// X3DToolKit is distributed in the hope that it will be useful,
/// but WITHOUT ANY WARRANTY; without even the implied warranty of
/// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
/// GNU General Public License for more details.

/// You should have received a copy of the GNU General Public License
/// along with X3DToolKit; if not, write to the Free Software
/// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA



/// Ce programme est libre, vous pouvez le redistribuer et/ou le modifier
/// selon les termes de la Licence Publique Gnrale GNU publie par la Free
/// Software Foundation (version 2 ou bien toute autre version ultrieure
/// choisie par vous).

/// Ce programme est distribu car potentiellement utile, mais SANS AUCUNE
/// GARANTIE, ni explicite ni implicite, y compris les garanties de
/// commercialisation ou d'adaptation dans un but spcifique. Reportez-vous
///  la Licence Publique Gnrale GNU pour plus de dtails.

/// Vous devez avoir reu une copie de la Licence Publique Gnrale GNU en
/// mme temps que ce programme ; si ce n'est pas le cas, crivez  la Free
/// Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
/// 02111-1307, tats-Unis. 

////////////////////////////////////////////////////////////////////////////////
//                            GLCone.h                                        //
////////////////////////////////////////////////////////////////////////////////

#ifndef GLCONE_H
#define GLCONE_H

#include "X3DGLGeometry3DNode.h"

namespace X3DTK {

class Cone;
class ConeDrawArray;

/// Class providing a implementation of the X3DGLNode corresponding to the X3DNode
/// Cone.

class GLCone : public X3DGLGeometry3DNode
{
public:
  /// Constructor.
  GLCone();
  /// Clones the node.
  virtual SFNode clone() const;
  /// Destructor.
  ~GLCone();

  /// Gets the radius.
  SFFloat &getBottomRadius() const {return (SFFloat &)_bottomRadius;};
  /// Gets the height.
  SFFloat &getHeight() const {return (SFFloat &)_height;};
  /// Gets the side.
  SFBool &getSide() const {return (SFBool &)_side;};
  /// Gets the bottom.
  SFBool &getBottom() const {return (SFBool &)_bottom;};
  /// Gets the ConeDrawArray.
  inline ConeDrawArray *&getConeDrawArray() const {return (ConeDrawArray *&)_coneArray;};

protected:
  /// Copy constructor.	   
  GLCone(const GLCone &C);
  
private:
  //GL attributes
  SFFloat _bottomRadius;
  SFFloat _height;
  SFBool _side;
  SFBool _bottom;
  ConeDrawArray *_coneArray;
};

}

#endif
