#include "GLIndexedFaceSet.h"
#include "IndexedFaceSet.h"
#include "GLGeometry3DNodes.h"

#include <list>

using namespace X3DTK;
using namespace std;

typedef struct
{
  SFInt32 face;
  unsigned short position;
} face_position;

typedef struct
{
  list<SFInt32> faceList;
  SFVec3f normal;
} part_normal;

GLIndexedFaceSet::GLIndexedFaceSet() 
: X3DGLComposedGeometryNode(), _ccw(true), _solid(false), _verticesDuplicated(false), _color(false), _texCoord(false)
{
  defineTagName("GLIndexedFaceSet", "GLGeometry3D");
}

           
GLIndexedFaceSet::GLIndexedFaceSet(const GLIndexedFaceSet &I)
: X3DGLComposedGeometryNode(I), _ccw(I._ccw), _solid(I._solid), _verticesDuplicated(I._verticesDuplicated), _color(I._color), _texCoord(I._texCoord), _N3F_V3FvertexFaceArray(I._N3F_V3FvertexFaceArray), _C4F_N3F_V3FvertexFaceArray(I._C4F_N3F_V3FvertexFaceArray), _T2F_N3F_V3FvertexFaceArray(I._T2F_N3F_V3FvertexFaceArray), _T2F_C4F_N3F_V3FvertexFaceArray(I._T2F_C4F_N3F_V3FvertexFaceArray), _indexFaceArray(I._indexFaceArray)
{
  defineTagName("GLIndexedFaceSet", "GLGeometry3D");
}

SFNode GLIndexedFaceSet::clone() const
{
  return new GLIndexedFaceSet(*this);
}

GLIndexedFaceSet::~GLIndexedFaceSet()
{
}

