#include "GLSphere.h"
#include "Sphere.h"
#include "SphereDrawArray.h"

using namespace X3DTK;

GLSphere::GLSphere()
: X3DGLGeometry3DNode(), _radius(0.0f), _sphereArray(0)
{
  defineTagName("GLSphere", "GLGeometry3D");
}

GLSphere::GLSphere(const GLSphere &S)
: X3DGLGeometry3DNode(S), _radius(S._radius), _sphereArray(0)
{
  defineTagName("GLSphere", "GLGeometry3D");
}

SFNode GLSphere::clone() const
{
  return new GLSphere(*this);
}

GLSphere::~GLSphere()
{
  _sphereArray->removeInstance();
}
