/// This file is part of the QGLViewer library
/// Copyright (C) 2002-2003  Yannick Le Goc (legoc@imag.fr)

/// http://www-imagis.imag.fr/Membres/Yannick.Legoc/X3D/


/// X3DToolKit is free software; you can redistribute it and/or modify
/// it under the terms of the GNU General Public License as published by
/// the Free Software Foundation; either version 2 of the License, or
/// (at your option) any later version.

/// X3DToolKit is distributed in the hope that it will be useful,
/// but WITHOUT ANY WARRANTY; without even the implied warranty of
/// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
/// GNU General Public License for more details.

/// You should have received a copy of the GNU General Public License
/// along with X3DToolKit; if not, write to the Free Software
/// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA



/// Ce programme est libre, vous pouvez le redistribuer et/ou le modifier
/// selon les termes de la Licence Publique Gnrale GNU publie par la Free
/// Software Foundation (version 2 ou bien toute autre version ultrieure
/// choisie par vous).

/// Ce programme est distribu car potentiellement utile, mais SANS AUCUNE
/// GARANTIE, ni explicite ni implicite, y compris les garanties de
/// commercialisation ou d'adaptation dans un but spcifique. Reportez-vous
///  la Licence Publique Gnrale GNU pour plus de dtails.

/// Vous devez avoir reu une copie de la Licence Publique Gnrale GNU en
/// mme temps que ce programme ; si ce n'est pas le cas, crivez  la Free
/// Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
/// 02111-1307, tats-Unis. 

////////////////////////////////////////////////////////////////////////////////
//                            GLPointSet.h                                    //
////////////////////////////////////////////////////////////////////////////////

#ifndef GLPOINTSET_H
#define GLPOINTSET_H

#include "X3DGLGeometryNode.h"

#include <vector>

namespace X3DTK {

class PointSet;

/// Class providing a implementation of the X3DGLNode corresponding to the X3DNode 
/// PointSet.

class GLPointSet : public X3DGLGeometryNode
{
public:
  /// Constructor.
  GLPointSet();
  /// Clones the node.
  virtual SFNode clone() const;
  /// Destructor.
  ~GLPointSet();

  /// gets the color.
  inline SFBool &getColor() const {return (SFBool &)_color;};
  /// Gets the pointArray.
  inline MFVec3f &getPointArray() const {return (MFVec3f &)_pointArray;};
  /// Gets the lineArrayArray.
  inline std::vector<C4UB_V3F> &getPointSetArray() const {return (std::vector<C4UB_V3F> &)_pointSetArray;};

protected: 
  /// Copy constructor.	       
  GLPointSet(const GLPointSet &P);
  
private:
  //GL attributes
  SFBool _color;
  
  MFVec3f _pointArray;
  std::vector<C4UB_V3F> _pointSetArray;
};

}

#endif
