/// This file is part of the QGLViewer library
/// Copyright (C) 2002-2003  Yannick Le Goc (legoc@imag.fr)

/// http://www-imagis.imag.fr/Membres/Yannick.Legoc/X3D/


/// X3DToolKit is free software; you can redistribute it and/or modify
/// it under the terms of the GNU General Public License as published by
/// the Free Software Foundation; either version 2 of the License, or
/// (at your option) any later version.

/// X3DToolKit is distributed in the hope that it will be useful,
/// but WITHOUT ANY WARRANTY; without even the implied warranty of
/// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
/// GNU General Public License for more details.

/// You should have received a copy of the GNU General Public License
/// along with X3DToolKit; if not, write to the Free Software
/// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA



/// Ce programme est libre, vous pouvez le redistribuer et/ou le modifier
/// selon les termes de la Licence Publique Gnrale GNU publie par la Free
/// Software Foundation (version 2 ou bien toute autre version ultrieure
/// choisie par vous).

/// Ce programme est distribu car potentiellement utile, mais SANS AUCUNE
/// GARANTIE, ni explicite ni implicite, y compris les garanties de
/// commercialisation ou d'adaptation dans un but spcifique. Reportez-vous
///  la Licence Publique Gnrale GNU pour plus de dtails.

/// Vous devez avoir reu une copie de la Licence Publique Gnrale GNU en
/// mme temps que ce programme ; si ce n'est pas le cas, crivez  la Free
/// Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
/// 02111-1307, tats-Unis. 

////////////////////////////////////////////////////////////////////////////////
//                            GLMaterial.h                                    //
////////////////////////////////////////////////////////////////////////////////

#ifndef GLMATERIAL_H
#define GLMATERIAL_H

#include "X3DGLMaterialNode.h"

#include <vector>

namespace X3DTK {

class Material;

/// Class providing a implementation of the X3DGLNode corresponding to the X3DNode 
/// Material.

class GLMaterial : public X3DGLMaterialNode
{
public:
  /// Constructor.
  GLMaterial();
  /// Clones the node.
  virtual SFNode clone() const;
  /// Destructor.
  ~GLMaterial();

  /// Gets the diffuseColor.
  inline MFFloat &getDiffuseColor() const {return (MFFloat &)_diffuseColor;};
  /// Gets the ambientColor.
  inline MFFloat &getAmbientColor() const {return (MFFloat &)_ambientColor;};
  /// Gets the emissiveColor.
  inline MFFloat &getEmissiveColor() const {return (MFFloat &)_emissiveColor;};
  /// Gets the shininess.
  inline SFFloat &getShininess() const {return (SFFloat &)_shininess;};
  /// Gets the specularColor.
  inline MFFloat &getSpecularColor() const {return (MFFloat &)_specularColor;};

protected:    
  /// Copy constructor.	   
  GLMaterial(const GLMaterial &M);
  
private:
  //GL attributes
  MFFloat _diffuseColor;
  MFFloat _ambientColor;
  MFFloat _emissiveColor;
  SFFloat _shininess;
  MFFloat _specularColor;
};

}

#endif
