#include "Scene.h"
#include "X3DChildNode.h"

#include <iostream>

using namespace X3DTK;
using namespace std;

Scene::Scene()
: X3DGroupingNode(), X3DBoundedObject()
{
  defineTagName("Scene", "Core");
  _sceneList.insert(this);
}

Scene::Scene(const Scene &S)
: X3DGroupingNode(S), X3DBoundedObject(S)
{
  defineTagName("Scene", "Core");
  _sceneList.insert(this);
}

SFNode Scene::clone() const
{
  return new Scene(*this);
}

Scene::~Scene()
{
}

void Scene::setFileName(SFString file)
{
  file_ = file;
}

void Scene::loadAttributes(const X3DFileElement *element)
{
  X3DGroupingNode::loadAttributes(element);
  X3DBoundedObject::loadAttributes(element); 
}

SFString Scene::writeAttributes() const
{
  return X3DGroupingNode::writeAttributes() + X3DBoundedObject::writeAttributes();
}
