#include "XercesFileElement.h"

#include <xercesc/util/XMLString.hpp>
#include <xercesc/sax2/Attributes.hpp>

#include <iostream>

using namespace std;
using namespace X3DTK;
XERCES_CPP_NAMESPACE_USE

class X3DTK::XercesFileElementImplementation
{
public:
  XercesFileElementImplementation(){};
  
  SFString _name;
  XERCES_CPP_NAMESPACE_QUALIFIER Attributes *_attributes;
};

XercesFileElement::XercesFileElement(const SFString &name, const void *const attributes)
: _impl(new XercesFileElementImplementation())
{
  _impl->_name = name;
  _impl->_attributes = (Attributes *)attributes;
}

XercesFileElement::~XercesFileElement()
{
}

SFString XercesFileElement::getName() const
{
  return _impl->_name;
}

SFString XercesFileElement::getAttribute(int i) const
{
  return XMLString::transcode(_impl->_attributes->getValue(i));
}

int XercesFileElement::getIndexAttribute(const SFString &attribute) const
{
  return _impl->_attributes->getIndex(XMLString::transcode((const char *)attribute));
}
