#include "Box.h"

using namespace X3DTK;

Box::Box()
:X3DGeometry3DNode(), size_(SFVec3f(2.0f, 2.0f, 2.0f))
{
  defineTagName("Box", "Geometry3D");
}

Box::Box(const SFVec3f &size)
:X3DGeometry3DNode(), size_(size)
{
  defineTagName("Box", "Geometry3D");
}

Box::Box(const Box &B)
:X3DGeometry3DNode(B), size_(B.size_)
{
  defineTagName("Box", "Geometry3D");
}

SFNode Box::clone() const
{
  return new Box(*this);
}

Box::~Box()
{
}

void Box::setSize(const SFVec3f &size)
{
  size_ = size;
}

void Box::loadAttributes(const X3DFileElement *element)
{
  int index;
  index = element->getIndexAttribute("size");
  if (index != -1)
    size_ = SFVec3f(element->getAttribute(index));
}

SFString Box::writeAttributes() const
{
  SFString attr;
  if (size_ != SFVec3f(2.0f, 2.0f, 2.0f))
      attr += " size=\"" + toSFString(size_) + "\"";
      
  return attr;    
}
