#include "Sphere.h"

using namespace X3DTK;

Sphere::Sphere()
: X3DGeometry3DNode(), radius_(1.0f)
{
  defineTagName("Sphere", "Geometry3D");
}

Sphere::Sphere(SFFloat radius)
: X3DGeometry3DNode(), radius_(radius)
{
  defineTagName("Sphere", "Geometry3D");
}

Sphere::Sphere(const Sphere &C) 
: X3DGeometry3DNode(C), radius_(C.radius_)
{
  defineTagName("Sphere", "Geometry3D");
}

SFNode Sphere::clone() const
{
  return new Sphere(*this);
}

Sphere::~Sphere()
{
}

void Sphere::setRadius(SFFloat radius)
{
  radius_ = radius;
}

void Sphere::loadAttributes(const X3DFileElement *element)
{
  int index;
  index = element->getIndexAttribute("radius");
  if (index != -1)
    radius_ = element->getAttribute(index).toFloat();
}

SFString Sphere::writeAttributes() const
{
  SFString attr;
  if (radius_ != 1.0f)
    attr += " radius=\"" + toSFString(radius_) + "\"";
  
  return attr;
}
