#include "X3DGroupingNode.h"

#include <iostream>

using namespace X3DTK;
using namespace std;

X3DGroupingNode::X3DGroupingNode()
: X3DChildNode()
{
  defineTagName("X3DGroupingNode", "Grouping");
}

X3DGroupingNode::X3DGroupingNode(const X3DGroupingNode &N)
: X3DChildNode(N), children(N.children)
{
  defineTagName("X3DGroupingNode", "Grouping");
}

SFNode X3DGroupingNode::clone() const
{
  return 0;
}

X3DGroupingNode::~X3DGroupingNode()
{
}

bool X3DGroupingNode::addChild(const SFNode &N)
{
  if (dynamic_cast<X3DChildNode *>(N) != 0)
  {
    children.push_back(N);
    addLink(this, N);
    return true;
  }
  
  cerr << "X3DGroupingNode::addChild : a node of type " << N->getTypeName() << " cannot be a child!" << endl;
  return false;    
}

bool X3DGroupingNode::setChild(const SFNode &N)
{
  if (dynamic_cast<X3DChildNode *>(N) != 0)
  {
    children.push_back(N);
    addLink(this, N);
    return true;
  }
  
  cerr << "X3DGroupingNode::setChild : a node of type " << N->getTypeName() << " cannot be a child!" << endl;
  return false;    
}

bool X3DGroupingNode::removeChild(const SFNode &N)
{
  MFNode::iterator res = find(children.begin(), children.end(), N);
  if (res != children.end())
  {
    children.erase(res);
    removeLink(this, N);
    return true;
  }  
    
  return false;
}

void X3DGroupingNode::removeScenesToChildren(const MFScene &sceneList)
{
  for (MFNode::iterator it = children.begin(); it != children.end(); ++it)
    removeScenes(*it, sceneList);
}

void X3DGroupingNode::addScenesToChildren(const MFScene &sceneList)
{
  for (MFNode::iterator it = children.begin(); it != children.end(); ++it)
    addScenes(*it, sceneList);
}
