#include "Shape.h"

using namespace X3DTK;

Shape::Shape()
: X3DShapeNode(), X3DBoundedObject()
{ 
  defineTagName("Shape", "Shape");
}

Shape::Shape(const X3DGeometryNode *geometry,  const X3DAppearanceNode *appearance,  const SFVec3f &bboxCenter,  const SFVec3f &bboxSize)
: X3DShapeNode(geometry, appearance), X3DBoundedObject(bboxCenter, bboxSize)
{
  defineTagName("Shape", "Shape");
}

Shape::Shape(const Shape &S)
: X3DShapeNode(S), X3DBoundedObject(S)
{
  defineTagName("Shape", "Shape");
}

SFNode Shape::clone() const
{
  return new Shape(*this);
}

Shape::~Shape()
{
}

void Shape::loadAttributes(const X3DFileElement *element)
{
  X3DBoundedObject::loadAttributes(element);
}

SFString Shape::writeAttributes() const
{
  return X3DBoundedObject::writeAttributes();
}
