#include "BboxUpdater.h"
#include "DefaultDFS.h"
#include "BboxUpdaterCoreVisitor.h"
#include "BboxUpdaterGeometry3DVisitor.h"
#include "BboxUpdaterGroupingVisitor.h"
#include "BboxUpdaterRenderingVisitor.h"
#include "BboxUpdaterShapeVisitor.h"

using namespace X3DTK;

BboxUpdater::BboxUpdater()
: X3DBboxUpdater()
{
  globalVariables = GVManager::getInstanceOf<BboxUpdaterGlobalVariables>();
    
  dfs = new DefaultDFS();
  dfs->setComponentVisitor(new BboxUpdaterCoreVisitor());
  dfs->setComponentVisitor(new BboxUpdaterGeometry3DVisitor());
  dfs->setComponentVisitor(new BboxUpdaterGroupingVisitor());
  dfs->setComponentVisitor(new BboxUpdaterRenderingVisitor());
  dfs->setComponentVisitor(new BboxUpdaterShapeVisitor());
}

BboxUpdater::~BboxUpdater()
{
  delete dfs;
}

void BboxUpdater::setComponentVisitor(X3DComponentVisitor *component)
{
  dfs->setComponentVisitor(component);
}

void BboxUpdater::update(X3DNode *N, bool staticProcessing)
{
  globalVariables->setStaticProcessing(staticProcessing);

  dfs->traverse(N);
  globalVariables->finish();
}
