#include "GLConverter.h"
#include "GLScene.h"
#include "GLCreator.h"
#include "GLUpdater.h"

#include <iostream>

using namespace X3DTK;
using namespace std;

GLConverter::GLConverter()
{
  _glcreator = new GLCreator();  
  _glupdater = new GLUpdater();  
}

GLConverter::~GLConverter()
{
  delete _glcreator;  
  delete _glupdater;
}

void GLConverter::setGLCreator(X3DGLCreator *creator)
{
  _glcreator = creator;  
}

void GLConverter::setGLUpdater(X3DGLUpdater *updater)
{
  _glupdater = updater;
}
  
GLScene *GLConverter::convert(Scene *S)
{
  GLScene *gs = static_cast<GLScene *>(_glcreator->create(S));
  _glupdater->update(gs);
  
  return gs;
}
