#include "GLCreator.h"
#include "DefaultDFS.h"
#include "GLCreatorCoreVisitor.h"
#include "GLCreatorGeometry3DVisitor.h"
#include "GLCreatorGroupingVisitor.h"
#include "GLCreatorRenderingVisitor.h"
#include "GLCreatorShapeVisitor.h"
#include "GLCreatorTexturingVisitor.h"
#include "GLScene.h"

using namespace X3DTK;

GLCreator::GLCreator()
: X3DGLCreator()
{
  globalVariables = GVManager::getInstanceOf<GLCreatorGlobalVariables>();
  dfs = new DefaultDFS();
  
  dfs->setComponentVisitor(new GLCreatorCoreVisitor());
  dfs->setComponentVisitor(new GLCreatorGeometry3DVisitor());
  dfs->setComponentVisitor(new GLCreatorGroupingVisitor());
  dfs->setComponentVisitor(new GLCreatorRenderingVisitor());
  dfs->setComponentVisitor(new GLCreatorShapeVisitor());
  dfs->setComponentVisitor(new GLCreatorTexturingVisitor());
}

GLCreator::~GLCreator()
{
  delete dfs;
}

void GLCreator::setComponentVisitor(X3DComponentVisitor *component)
{
  dfs->setComponentVisitor(component);
}

X3DGLNode *GLCreator::create(X3DNode *N)
{
  globalVariables->init();
  dfs->traverse(N);
  globalVariables->finish();
  
  return globalVariables->getRoot();
}
