#include "GLCreatorCoreVisitor.h"
#include "Scene.h"
#include "X3DNode.h"
#include "GLScene.h"

#include <iostream>

using namespace X3DTK;
using namespace std;

GLCreatorCoreVisitor::GLCreatorCoreVisitor()
: CoreVisitor()
{
  // Enter functions.
  defineNewEnterFunction<GLCreatorCoreVisitor, Scene>(&GLCreatorCoreVisitor::enterScene);
  defineNewEnterFunction<GLCreatorCoreVisitor, X3DNode>(&GLCreatorCoreVisitor::enterX3DNode);
  // Leave functions.
  defineNewLeaveFunction<GLCreatorCoreVisitor, X3DNode>(&GLCreatorCoreVisitor::leaveX3DNode);

  // GlobalVariables assignation.
  globalVariables = GVManager::getInstanceOf<GLCreatorGlobalVariables>();
}

GLCreatorCoreVisitor::~GLCreatorCoreVisitor()
{
}

void GLCreatorCoreVisitor::enterScene(Scene *S) const
{
  GLScene *GS = new GLScene();
  GS->setLink(S);
  globalVariables->pushNode(GS);
}

void GLCreatorCoreVisitor::enterX3DNode(X3DNode *N) const
{
  cerr << "enterX3DNode must not be called for " << N->getTypeName() << " !" << endl;
}

void GLCreatorCoreVisitor::leaveX3DNode(X3DNode *N) const
{
  globalVariables->popNode();
}

