#include "GLCreatorGroupingVisitor.h"
#include "Group.h"
#include "StaticGroup.h"
#include "Transform.h"
#include "GLGroup.h"
#include "GLStaticGroup.h"
#include "GLTransform.h"

#include <iostream>

using namespace X3DTK;
using namespace std;

GLCreatorGroupingVisitor::GLCreatorGroupingVisitor()
: GroupingVisitor()
{
  // Enter functions.
  defineNewEnterFunction<GLCreatorGroupingVisitor, Group>(&GLCreatorGroupingVisitor::enterGroup);
  defineNewEnterFunction<GLCreatorGroupingVisitor, StaticGroup>(&GLCreatorGroupingVisitor::enterStaticGroup);
  defineNewEnterFunction<GLCreatorGroupingVisitor, Transform>(&GLCreatorGroupingVisitor::enterTransform);

  // GlobalVariables assignation.
  globalVariables = GVManager::getInstanceOf<GLCreatorGlobalVariables>();
}

GLCreatorGroupingVisitor::~GLCreatorGroupingVisitor()
{
}

void GLCreatorGroupingVisitor::enterGroup(Group *G) const
{
  GLGroup *GG = new GLGroup();
  GG->setLink(G);
  globalVariables->getTop()->addChild(GG);
  globalVariables->pushNode(GG);
}

void GLCreatorGroupingVisitor::enterStaticGroup(StaticGroup *S) const
{
  GLStaticGroup *GS = new GLStaticGroup();
  GS->setLink(S);
  globalVariables->getTop()->addChild(GS);
  globalVariables->pushNode(GS); 
}

void GLCreatorGroupingVisitor::enterTransform(Transform *T) const
{
  GLTransform *GT = new GLTransform();
  GT->setLink(T);
  globalVariables->getTop()->addChild(GT);
  globalVariables->pushNode(GT);
}

