#include "GLCreatorShapeVisitor.h"
#include "Appearance.h"
#include "FillProperties.h"
#include "LineProperties.h"
#include "Material.h"
#include "Shape.h"
#include "GLAppearance.h"
#include "GLFillProperties.h"
#include "GLLineProperties.h"
#include "GLMaterial.h"
#include "GLShape.h"

using namespace X3DTK;

GLCreatorShapeVisitor::GLCreatorShapeVisitor()
: ShapeVisitor()
{
  // Enter functions.
  defineNewEnterFunction<GLCreatorShapeVisitor, Appearance>(&GLCreatorShapeVisitor::enterAppearance);
  defineNewEnterFunction<GLCreatorShapeVisitor, FillProperties>(&GLCreatorShapeVisitor::enterFillProperties);
  defineNewEnterFunction<GLCreatorShapeVisitor, LineProperties>(&GLCreatorShapeVisitor::enterLineProperties);
  defineNewEnterFunction<GLCreatorShapeVisitor, Material>(&GLCreatorShapeVisitor::enterMaterial);
  defineNewEnterFunction<GLCreatorShapeVisitor, Shape>(&GLCreatorShapeVisitor::enterShape);

  // GlobalVariables assignation.
  globalVariables = GVManager::getInstanceOf<GLCreatorGlobalVariables>();
}

GLCreatorShapeVisitor::~GLCreatorShapeVisitor()
{
}

void GLCreatorShapeVisitor::enterAppearance(Appearance *A) const
{
  GLAppearance *GA = new GLAppearance();
  GA->setLink(A);
  globalVariables->getTop()->addChild(GA);
  globalVariables->pushNode(GA);
}

void GLCreatorShapeVisitor::enterFillProperties(FillProperties *F) const
{
  GLFillProperties *GF = new GLFillProperties();
  GF->setLink(F);
  globalVariables->getTop()->addChild(GF);
  globalVariables->pushNode(GF);
}

void GLCreatorShapeVisitor::enterLineProperties(LineProperties *L) const
{
  GLLineProperties *GL = new GLLineProperties();
  GL->setLink(L);
  globalVariables->getTop()->addChild(GL);
  globalVariables->pushNode(GL);
}

void GLCreatorShapeVisitor::enterMaterial(Material *M) const
{
  GLMaterial *GM = new GLMaterial();
  GM->setLink(M);
  globalVariables->getTop()->addChild(GM);
  globalVariables->pushNode(GM);
}

void GLCreatorShapeVisitor::enterShape(Shape *S) const
{
  GLShape *GS = new GLShape();
  GS->setLink(S);
  globalVariables->getTop()->addChild(GS);
  globalVariables->pushNode(GS);
}

