#include "GLNormalRenderer.h"
#include "DefaultGLDFS.h"
#include "GLNormalRendererGLCoreVisitor.h"
#include "GLNormalRendererGLGeometry3DVisitor.h"
#include "GLNormalRendererGLGroupingVisitor.h"
#include "X3DGLNode.h"

#include <iostream>

using namespace std;
using namespace X3DTK;

GLNormalRenderer::GLNormalRenderer()
{
  dfs = new DefaultGLDFS();
  
  dfs->setComponentVisitor(new GLNormalRendererGLCoreVisitor());
  dfs->setComponentVisitor(new GLNormalRendererGLGeometry3DVisitor());
  dfs->setComponentVisitor(new GLNormalRendererGLGroupingVisitor());
}

GLNormalRenderer::~GLNormalRenderer()
{
  delete dfs;
}

void GLNormalRenderer::setComponentVisitor(X3DComponentVisitor *component)
{
  dfs->setComponentVisitor(component);
} 

void GLNormalRenderer::render(X3DGLNode *N) const
{
  dfs->traverse(N);
}
