#include "GLNormalRendererGLGeometry3DVisitor.h"
#include "GLBox.h"
#include "GLCone.h"
#include "GLCylinder.h"
#include "GLIndexedFaceSet.h"
#include "GLSphere.h"

using namespace X3DTK;

GLNormalRendererGLGeometry3DVisitor::GLNormalRendererGLGeometry3DVisitor()
: GLGeometry3DVisitor()
{
  // Enter functions.
  defineNewEnterFunction<GLNormalRendererGLGeometry3DVisitor, GLBox>(&GLNormalRendererGLGeometry3DVisitor::enterGLBox);
  defineNewEnterFunction<GLNormalRendererGLGeometry3DVisitor, GLCone>(&GLNormalRendererGLGeometry3DVisitor::enterGLCone);
  defineNewEnterFunction<GLNormalRendererGLGeometry3DVisitor, GLCylinder>(&GLNormalRendererGLGeometry3DVisitor::enterGLCylinder);
  defineNewEnterFunction<GLNormalRendererGLGeometry3DVisitor, GLIndexedFaceSet>(&GLNormalRendererGLGeometry3DVisitor::enterGLIndexedFaceSet);
  defineNewEnterFunction<GLNormalRendererGLGeometry3DVisitor, GLSphere>(&GLNormalRendererGLGeometry3DVisitor::enterGLSphere);
}

GLNormalRendererGLGeometry3DVisitor::~GLNormalRendererGLGeometry3DVisitor()
{
}

void GLNormalRendererGLGeometry3DVisitor::enterGLBox(GLBox *G) const
{
}

void GLNormalRendererGLGeometry3DVisitor::enterGLCone(GLCone *G) const
{
}

void GLNormalRendererGLGeometry3DVisitor::enterGLCylinder(GLCylinder *G) const
{
}

void GLNormalRendererGLGeometry3DVisitor::enterGLIndexedFaceSet(GLIndexedFaceSet *G) const
{
  
  if ((G->getColor()) && (G->getTexCoord()))
  {
  }  
    
  if ((G->getColor()) && (!G->getTexCoord()))
  {
    vector<C4F_N3F_V3F> &vertexArray = G->getC4F_N3F_V3FvertexFaceArray();
    
//    glBegin(GL_LINES);
    
    for (vector<C4F_N3F_V3F>::const_iterator it = vertexArray.begin(); it != vertexArray.end(); ++it)
    {
      SFVec3f vertex = (*it).vertex;
      SFVec3f normal = (*it).normal;
      cout << "vertex = " << vertex << endl;
      cout << "normal = " << normal << endl;
    }
    
//    glEnd();    
    
  }  
    
  if ((!G->getColor()) && (G->getTexCoord()))
  {
    vector<T2F_N3F_V3F> &vertexArray = G->getT2F_N3F_V3FvertexFaceArray();
    
//    glBegin(GL_LINES);
    
    for (vector<T2F_N3F_V3F>::const_iterator it = vertexArray.begin(); it != vertexArray.end(); ++it)
    {
      SFVec3f vertex = (*it).vertex;
      SFVec3f normal = (*it).normal;
      cout << "vertex = " << vertex << endl;
      cout << "normal = " << normal << endl;
    }
    
//    glEnd();    
    
  }  
  
  if ((!G->getColor()) && (!G->getTexCoord()))
  {
    vector<N3F_V3F> &vertexArray = G->getN3F_V3FvertexFaceArray();
    
//    glBegin(GL_LINES);
    
    for (vector<N3F_V3F>::const_iterator it = vertexArray.begin(); it != vertexArray.end(); ++it)
    {
      SFVec3f vertex = (*it).vertex;
      SFVec3f normal = (*it).normal;
      cout << "vertex = " << vertex << endl;
      cout << "normal = " << normal << endl;
    }
    
//    glEnd();    
  }
}

void GLNormalRendererGLGeometry3DVisitor::enterGLSphere(GLSphere *G) const
{
}

