#include "GLNormalRendererGLGroupingVisitor.h"
#include "GLTransform.h"

using namespace X3DTK;

GLNormalRendererGLGroupingVisitor::GLNormalRendererGLGroupingVisitor()
: GLGroupingVisitor()
{
  // Enter functions.
  defineNewEnterFunction<GLNormalRendererGLGroupingVisitor, GLTransform>(&GLNormalRendererGLGroupingVisitor::enterGLTransform);

  // Leave functions
  defineNewLeaveFunction<GLNormalRendererGLGroupingVisitor, GLTransform>(&GLNormalRendererGLGroupingVisitor::leaveGLTransform);
}

GLNormalRendererGLGroupingVisitor::~GLNormalRendererGLGroupingVisitor()
{
}

void GLNormalRendererGLGroupingVisitor::enterGLTransform(GLTransform *G) const
{
  glMatrixMode(GL_MODELVIEW);
  glPushMatrix();
  glMultMatrixf(&G->getTransformMatrix().front());
}

void GLNormalRendererGLGroupingVisitor::leaveGLTransform(GLTransform *G) const
{
  glMatrixMode(GL_MODELVIEW);
  glPopMatrix();  
}
