#include "GLRendererGLTexturingVisitor.h"
#include "GLImageTexture.h"

#include <iostream> 

using namespace X3DTK;
using namespace std;

GLRendererGLTexturingVisitor::GLRendererGLTexturingVisitor()
: GLTexturingVisitor()
{
  // Enter functions.
  defineNewEnterFunction<GLRendererGLTexturingVisitor, GLImageTexture>(&GLRendererGLTexturingVisitor::enterGLImageTexture);

  // GlobalVariables assignation.
  globalVariables = GVManager::getInstanceOf<GLRendererGlobalVariables>();
}

GLRendererGLTexturingVisitor::~GLRendererGLTexturingVisitor()
{
}

void GLRendererGLTexturingVisitor::enterGLImageTexture(GLImageTexture *G) const
{
  glTexEnvf(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_REPLACE);
  glBindTexture(GL_TEXTURE_2D, G->getTexName());
  
  glMatrixMode(GL_TEXTURE);
  glLoadMatrixf(&G->getTextureTransform().front());
}
