#include "GLUpdater.h"
#include "DefaultGLDFS.h"
#include "GLUpdaterGLCoreVisitor.h"
#include "GLUpdaterGLGeometry3DVisitor.h"
#include "GLUpdaterGLGroupingVisitor.h"
#include "GLUpdaterGLRenderingVisitor.h"
#include "GLUpdaterGLShapeVisitor.h"
#include "GLUpdaterGLTexturingVisitor.h"
#include "GLScene.h"

using namespace X3DTK;

GLUpdater::GLUpdater()
: X3DGLUpdater()
{
  globalVariables = GVManager::getInstanceOf<GLUpdaterGlobalVariables>();
  dfs = new DefaultGLDFS();
  
  dfs->setComponentVisitor(new GLUpdaterGLCoreVisitor());
  dfs->setComponentVisitor(new GLUpdaterGLGeometry3DVisitor());
  dfs->setComponentVisitor(new GLUpdaterGLGroupingVisitor());
  dfs->setComponentVisitor(new GLUpdaterGLRenderingVisitor());
  dfs->setComponentVisitor(new GLUpdaterGLShapeVisitor());
  dfs->setComponentVisitor(new GLUpdaterGLTexturingVisitor());
}

GLUpdater::~GLUpdater()
{
  delete dfs;
}

void GLUpdater::setComponentVisitor(X3DComponentVisitor *component)
{
  dfs->setComponentVisitor(component);
}

void GLUpdater::update(GLScene *S)
{
  globalVariables->setPath(static_cast<Scene *>(S->getLink())->getFileName().getPath());
  dfs->traverse(S);
}
