#include "MemReleaserRootVisitor.h"
#include "Scene.h"
#include "X3DAbstractNode.h"

#include <iostream>

using namespace X3DTK;
using namespace std;

MemReleaserRootVisitor::MemReleaserRootVisitor()
: RootVisitor()
{
  // Enter functions.
  defineNewEnterFunction<MemReleaserRootVisitor, X3DAbstractNode>(&MemReleaserRootVisitor::enterX3DAbstractNode);
  
  // Walk on functions.
  defineNewWalkOnFunction<MemReleaserRootVisitor, X3DAbstractNode>(&MemReleaserRootVisitor::walkOnX3DAbstractNode);  
    
  // Leave functions.
  defineNewLeaveFunction<MemReleaserRootVisitor, X3DAbstractNode>(&MemReleaserRootVisitor::leaveX3DAbstractNode);

  // GlobalVariables assignation.
  globalVariables = GVManager::getInstanceOf<MemReleaserGlobalVariables>();
}

MemReleaserRootVisitor::~MemReleaserRootVisitor()
{
}

void MemReleaserRootVisitor::enterX3DAbstractNode(X3DAbstractNode *N) const
{
/*  cout << "Node " << (void *)N << " of typeName " << N->getTypeName() << " belongs to Scenes:" << endl;
  cout << "  ";
  MFScene list = N->getSceneList();
  for (MFScene::const_iterator it = list.begin(); it != list.end(); ++it)
    cout << (void *)(*it) << ", ";
  cout << endl;*/
  
  // if here, then the parent has to be deleted.
  SFNode P = globalVariables->getParent();
  if (P != 0)
  {
    P->removeChild(N);
  }  
    
  if (N->getParentList().size() == 0)
    globalVariables->setDelete(true);
  else
    globalVariables->setDelete(false);
      
  globalVariables->pushParent(N);
}

bool MemReleaserRootVisitor::walkOnX3DAbstractNode(X3DAbstractNode *N, SFNode child) const
{
  return globalVariables->getDelete();
}

void MemReleaserRootVisitor::leaveX3DAbstractNode(X3DAbstractNode *N) const
{
  globalVariables->popParent();
    
  if (globalVariables->getDelete())
  {
    //cout << "deletes " << N->getTypeName() << endl;
    delete N;
    //cout << "deleted" << endl;
  }
  else
    globalVariables->setDelete(true);
}

