#include "SceneToFileGlobalVariables.h"
#include "X3DAbstractNode.h"

using namespace X3DTK;
using namespace std;

SceneToFileGlobalVariables::SceneToFileGlobalVariables()
: GlobalVariables(), _lineNumber(-1), _tab("  ")
{
}

SceneToFileGlobalVariables::~SceneToFileGlobalVariables()
{
}

void SceneToFileGlobalVariables::pushHasUSE(bool value)
{
  _hasUSEStack.push_front(value);
}

void SceneToFileGlobalVariables::newLine()
{
  ++_lineNumber;
  SFString l;
  _output.push_back(SFString(_tab));
}

void SceneToFileGlobalVariables::pushCurrentLine()
{
  _lineStack.push_front(_lineNumber);
}

void SceneToFileGlobalVariables::writeCurrentLine(const SFString &string)
{
  _output.back() += string;
}

void SceneToFileGlobalVariables::writeOpeningLine(const SFString &string)
{
  _output[_lineStack.front()] += string;
}

void SceneToFileGlobalVariables::addTab()
{
  _tab += "  ";
}

void SceneToFileGlobalVariables::removeTab()
{
  _tab.erase(0, 2);
}

bool SceneToFileGlobalVariables::hasChild()
{
  return (_lineNumber == _lineStack.front());
}

void SceneToFileGlobalVariables::popHasUSE()
{
  _hasUSEStack.pop_front();
}

void SceneToFileGlobalVariables::popLine()
{
  _lineStack.pop_front();
}

SFString SceneToFileGlobalVariables::getDEF(const SFNode &N)
{
  //finding name
  SFString DEF = X3DAbstractNode::DEFDict.getNameOfNode(N);
  if (DEF == "")
    return "";
  
  //the DEF doesn't exist
  //inserting the new DEF
  bool found = false;
  for (list<SFString>::const_iterator it = _DEFList.begin(); it != _DEFList.end(); ++it)
    if (*it == DEF)
    {
      found = true;
      break;
    }  
    
  if (!found)
  {
    _DEFList.push_back(DEF);
    return SFString(" DEF=\"") + DEF + "\"";  
  }
  return ""; 
}

SFString SceneToFileGlobalVariables::getUSE(const SFNode &N) const
{
  //finding name
  SFString DEF = X3DAbstractNode::DEFDict.getNameOfNode(N);
  if (DEF == "")
    return "";
  
  bool found = false;
  for (list<SFString>::const_iterator it = _DEFList.begin(); it != _DEFList.end(); ++it)
    if (*it == DEF)
    {
      found = true;
      break;
    }  
    
  if (found)
    return SFString(" USE=\"") + DEF + "\"";

  return "";  
}
